︠e66e1327-b4e0-47cc-914f-7766e524d25c︠
#Exercise 1. Make a function convert_angle(t, p) that takes an angle t and parameter p.  Zero value of p indicates that the angle t is in degrees, and the function should return the value of the angle in radians; value p = 1  indicates that the angle t is in radians, and the function should return the measure of this angle in degrees.
def convert_angle(t,p):
    if p==0:
        angle=pi*t/180
    else:
        angle=rad*180/pi# Should be t*180/pi
    return angle

︡3d94bc85-2d7f-4c2c-9ec1-b4f7b7a97a59︡
︠172ac10d-f8be-4112-8da8-15b23223bd62s︠
convert_angle(90,0)
︡67b0995d-ee85-430f-80d4-8ceb990ef7f8︡{"stdout":"1/2*pi\n"}︡{"done":true}
︠e1006f4b-bb9d-4e8a-8d20-205d7532bf6cs︠


########################
#Exercise 4. Make a figure similar to Fig. 10.4 in Chapter 10 for the sum cos(3 Pi*t)+cos(2.7 Pi*t).
#The exercise is similar to the example about beats in Chapter 10.
︡1eed2668-efbb-4e7a-bcf1-77c87a347476︡{"done":true}
︠970943e7-6d53-419e-92e2-5b1b329a45c7s︠
f(t)=2*cos(5.7*pi*t/2)*cos(.15*pi*t)
fplot=plot(f,-11,11,color='red',thickness=3)
top=plot(-2*cos(.15*pi*t),-11,11,color='blue',thickness=2)
bottom=plot(2*cos(.15*pi*t),-11,11,color='blue',thickness=2)
(fplot+top+bottom).show()

︡f6ff11dc-ce02-4461-933f-6efd0cbbf231︡{"file":{"filename":"/home/user/.sage/temp/project-fdca50c1-5926-45c5-a180-d8d3e7f819b2/576/tmp_2oP_Fh.svg","show":true,"text":null,"uuid":"e2550d32-0e39-4c85-bfc9-216c4916dea9"},"once":false}︡{"done":true}
︠dcfc760a-3530-49bf-b810-6a4979020e2cs︠
reset
︡00deba91-43ac-43d5-bc24-375c780ed9ed︡{"stdout":"<function reset at 0x7f4cd92ae0c8>\n"}︡{"done":true}
︠c6a39509-0c69-405c-885a-1d02dab5bc21s︠
########################
#Exercise 6.  Make a CAS function acoef(f(x), n) that takes two inputs, a piecewise differentiable 2π-periodic function f and an integer n and returns a list of n+1 Fourier coefficients a[k],  k=0, 1, ..., n, of the function f.
#Use the formula for a[k] calculation in Chapter 10.
def acoef(f,n,t0,T):
    L=[integral(f*cos(k*t),t,t0,T) for k in range(n+1) ]
    return [c/pi for c in L]
︡7c324db8-0574-48f2-9838-76b4f2b7e254︡{"done":true}
︠d4b1f15e-e181-4866-9a72-031fbbda33c2︠
#integral?
︡44643704-a27f-4693-987e-b0016a0d43ed︡{"done":true}
︠9a3e51ef-e4a9-426a-b704-729bd74d8fabs︠
#My example
f(t)=t^2
acoef(f,6,-pi,pi)
︡e4efd460-eb28-4bab-b78d-367b3d95d374︡{"stdout":"[2/3*pi^2, -4, 1, -4/9, 1/4, -4/25, 1/9]"}︡{"stdout":"\n"}︡{"done":true}
︠dfcc7714-57f5-4d92-8589-3327326808e8︠
#Your example: g(t)=t for 0<t<=2*pi ##Incorrect example
f(t)=t^2
acoef(f,2,-pi,pi)

︡ce34421d-5a5b-49bc-b882-0f7272377e32︡{"stdout":"[2/3*pi^2, -4, 1]\n"}︡{"done":true}
︠92de1cc9-3ba4-4a2c-9d23-bc98f0f2ccef︠
︡350ea098-1ad4-4416-a9e8-00c56a4e2471︡
︠9fd45651-64d0-449c-b2f2-ddd539eb3711s︠
#######################
#Exercise 7.  Make a CAS function bcoef(f(x), n) that takes two arguments, a piecewise differentiable 2π-periodic function and an integer n and returns a list of n Fourier coefficients b[k],  k=1, 2, ..., n, of the function f.
#Use the formula for b[k] calculation in Chapter 10.
#Similar to Exercise 6.
def bcoef(f,n,t0,T):
    L=[integral(f*sin(k*t),t,t0,T) for k in range(n+1) ]
    return [l/pi for l in L]

g(t)=t
bcoef(g,6,-pi,pi)
︡8e40757d-a356-4021-b789-328567a9aa05︡{"stdout":"[0, 2, -1, 2/3, -1/2, 2/5, -1/3]"}︡{"stdout":"\n"}︡{"done":true}
︠26c540a7-631e-49c6-8c87-3863edca903e︠
#######################
#Exercise 8.  Consider the 2π-periodic function f(t) = abs(t), t in [-Pi, Pi]  (the triangular wave function).
#(a) Find three partial sums S__n,  n=3, 4, 6, of the Fourier series for this function.
f(t)=abs(t)
acoef(f,6,-pi,pi)

︡6f87ac9b-9d28-48f3-9fd5-22fe419a1990︡{"stdout":"[pi, -4/pi, 0, -4/9/pi, 0, -4/25/pi, 0]"}︡{"stdout":"\n"}︡{"done":true}
︠429ffd11-102c-4770-87ba-75ac2bc1836c︠
#(b) Make three figures, each with the pairs of graphs f and one of the partial sums S__n, n=3, 4, 6, over three periods.
#Be careful, the formula for the function for t beyond the interval [-pi,pi] is different from abs(t).






︡7cfb0d92-5a6a-45f9-8d0c-7c54d2f226e3︡
︠5dcb6a81-81fd-43c2-9f2c-b4c0bcc0577a︠
#######################
#Exercise 10.
#(a) Construct the Fourier series for the function g(t) = sin(t) for 0<=t<pi, g(t)=0 for pi<= t < 2*Pi.
#Directions: Use your functions in Exercise 6 and Exercise 7 to find several Fourier coefficients a[k] and b[k]. By visual inspection, determine the pattern and write the Fourier series.
#(b) Plot the function and one of its partial Fourier series in one figure.


︡5646bf86-d924-4ae6-bb76-061acbe71a71︡
︠8335971a-1daf-4dc0-8e1b-22108ace7a8a︠
#piecewise?
︡1a8c18a6-c663-495c-b14c-150cd0296318︡{"done":true}
︠922ac9ae-cf53-4a55-ab47-a9e3905e4f3a︠
var('t')
s=piecewise([([0,pi],sin(t)),((pi,2*pi),0)]) #Just for plotting
︡4bfb96fe-7fa9-4a3f-8d1b-cc9e5be381f2︡{"stdout":"t\n"}︡{"done":true}
︠98bd8e82-8a8c-44b0-85a2-9b5743d27185︠
f_plot=plot(s,(t,0,2*pi),color='red',figsize=[4,2]);f_plot
︡140f560c-727e-4c78-a24d-14607c1c9a32︡{"file":{"filename":"/home/user/.sage/temp/project-c2e46271-e550-4aa2-9e76-891fcc7c29eb/3610/tmp_jeAq3Y.svg","show":true,"text":null,"uuid":"a71942a8-833c-4f40-af86-3f5a9af8c323"},"once":false}︡{"done":true}
︠63278b49-5a24-4499-b097-875c8b71c4e6︠

︡978595bf-ddd8-4171-b79a-da667f0c9e24︡
︠3e23e138-8307-46a2-a340-a1304e11e7db︠
# Integration of a piecewise function creates a problem:
#test=acoef(s,3,0,2*pi);test
︡ada3d329-092e-4ba1-8658-f37bb513b675︡
︠67939c3c-12f9-4573-b052-18d73dc0712d︠
# To overcome the problem, I used the specific feature of the function: it is zero for pi<=t<=2*pi.
A=acoef(?,?,?,pi);A
︡9245cba2-eb86-4abc-8d00-520ab9149016︡{"stdout":"[2/pi, 0, -2/3/pi, 0]"}︡{"stdout":"\n"}︡{"done":true}
︠388686fc-ab12-48b4-b560-39c58c4f5801︠
B=bcoef(?);B
︡3c413684-e98c-488b-89c5-7d14a48312d2︡{"stdout":"[0, 1/2, 0, 0]"}︡{"stdout":"\n"}︡{"done":true}
︠081a2895-0d07-487b-a99a-00d26ee31ef6︠
S5(t)=?
︡5aaba0aa-fe82-4088-9b05-bc0d63beada9︡{"done":true}
︠f1b6613c-7a52-42dd-bc1b-6e236b1c0781︠
s5_plot=plot(?,(t,?,?), linestyle="--")
︡018f7f90-f2fd-4790-ba5a-c708c99d5c65︡{"done":true}
︠0aa24cce-dc3b-4c6b-8955-d554ce06647c︠
(f_plot+s5_plot).show()
︡80ac04ab-9004-455f-9cb2-bb3f79b9dae9︡{"file":{"filename":"/home/user/.sage/temp/project-c2e46271-e550-4aa2-9e76-891fcc7c29eb/3610/tmp_SYoWHp.svg","show":true,"text":null,"uuid":"38d4a0c8-d40c-426b-9119-4b5070f7063e"},"once":false}︡{"done":true}
︠8701eb79-3a76-44a3-9216-1dff907e228e︠
## Exercises 8 and 10 not done; Exercises 6: incorrect example (-0.5); Exercise 1: conversion from radians to degrees incorrect (-0.5). Total: 4/6 
︠6a4d89f6-85a6-48e7-ae52-2c97af795e46︠









